/* Includes ------------------------------------------------------------------*/
#include "M0_Control_Library.h"

/* Private typedef ----------------------------------------------------------*/
/* Private define -----------------------------------------------------------*/
/* Private macro ------------------------------------------------------------*/
/* Private functions --------------------------------------------------------*/
/* Private variables --------------------------------------------------------*/
/* Variables ----------------------------------------------------------------*/
LBG_Paramter_Type       LBG_Para_M;      //LBG۲ṹ
Speed_PLL_Type          LBG_Speed_PLL_M; //תٹ۲PLLṹ嶨
LBG_Cal_Structure_Type  LBG_Cal_M;       //LBG۲ṹ
Observer_Adaptor_type   LBG_Adaptor_M;   //LBG۲۷˲ṹ
Observer_Status_Type    LBG_Status_M;    //LBG۲״̬ṹ
LBG_EMF_Init_Type       LBG_EMF_InitPara_M;     //LBG۲Ƴʼ
_iq24 LBG_SpeedBuffer_M[LBG_SPEED_BUFFERSIZE_M];//۲תƽֵ
BuffPara_Type LBG_SpeedBuffPara_M;       //۲תƽֵ

/******************************************************************************
* Function Name : LBG_Parameter_Define
* Description   : LBG۲
* Input         : ۲ṹָ룬໷ṹָ롢˲ṹָ롢۲״̬ṹָ
* Output        : None
* Return        : None
******************************************************************************/
void LBG_Parameter_Define (LBG_Paramter_Type *LBG_Para,LBG_Cal_Structure_Type *LBG_Cal_Struc,\
                        BuffPara_Type *BuffPara,Observer_Status_Type *LBGStatus,\
                        Speed_PLL_Type *Speed_PLL_Struc,Observer_Adaptor_type *Adaptor)
{
    //LBG۲
    LBG_Para->CalFreq = FREQ_SVPWM;
    LBG_Para->CalT = _IQ(1.0)/FREQ_SVPWM;
    LBG_Para->K1CerrC = LBG_K1_CERROR_CURR_M;
    LBG_Para->K2CerrE = LBG_K2_CERROR_EMF_M;

    //LBG۲
    LBG_Cal_Struc->EUlim = LBG_MAX_EMF_M;
    LBG_Cal_Struc->ELlim = LBG_MIN_EMF_M;
    LBG_Cal_Struc->CUlim = LBG_MAX_CURR_M;
    LBG_Cal_Struc->CLlim = LBG_MIN_CURR_M;

    //LBG۲໷
    Speed_PLL_Struc->Kpreal = PLL_KP_M;
    Speed_PLL_Struc->Kireal = PLL_KI_M;
    Speed_PLL_Struc->Upper_Lim = LBG_SPEED_MAX_M;
    Speed_PLL_Struc->Lower_Lim = LBG_SPEED_MIN_M;

    //LBG˲
    Adaptor->Enable = LBG_ADAPTOR_ENABLE;
    Adaptor->Gain = LBG_ADAPTOR_COEF_M;

    //LBG۲תƽֵ
    BuffPara->Length = LBG_SPEED_BUFFERSIZE_M;

    //LBG۲״̬ж
    LBGStatus->OverspeedThresh = LBG_OVERSPEED_THRESH_M;
    LBGStatus->OverspeedcntThresh = LBG_OVERSPEED_CNT_THRESH_M;
    LBGStatus->UnderspeedThresh = LBG_UNDERSPEED_THRESH_M;
    LBGStatus->UnderspeedcntThresh = LBG_UNDERSPEED_CNT_THRESH_M;
    LBGStatus->VarianceThresh = LBG_SPEED_VARIANCE_THRESH_M;
    LBGStatus->UnstableCntThresh = LBG_UNSTABLE_CNT_THRESH_M;
    LBGStatus->UnstableSpeedThresh = LBG_UNSTABLE_SPEED_THRESH_M;
    LBGStatus->ConvergeCntThresh = LBG_CONVERGED_CNT_THRESH_M;
    LBGStatus->ConvergeUpper = LBG_CONVERGED_UPPER_THRESH_M;
    LBGStatus->ConvergeLower = LBG_CONVERGED_LOWER_THRESH_M;
    LBGStatus->ConvergeEmfBand = LBG_CONVERGED_EMF_THRESH_M;
    LBGStatus->StallSpeedBand = LBG_STALLBAND_M;
    LBGStatus->StallSpeed = LBG_STALLSPEED_M;
    LBGStatus->StallCurr =  LBG_STALLCURR_M;
    LBGStatus->StallCntThresh = LBG_STALL_CNT_THRESH_M;
    LBGStatus->ReverseCntThresh = LBG_REVERSE_CNT_THRESH_M;
    LBGStatus->ReverseSpeedThresh = LBG_REVERSE_SPEED_THRESH_M;
}

/******************************************************************************
* Function Name : LBG_Status_Init
* Description   : LBG۲״̬ʼ
* Input         : ۲ṹָ룬໷ṹָ롢˲ṹָ롢۲״̬ṹָ
* Output        : None
* Return        : None
******************************************************************************/
void LBG_Status_Init (LBG_Cal_Structure_Type *LBG_Cal_Struc,Speed_PLL_Type *Speed_PLL_Struc,\
                    Observer_Adaptor_type *Adaptor,Observer_Status_Type *LBGStatus)
{
    //LBG۲ʼ
    LBG_Cal_Struc->CalCnt = 0;

    LBG_Cal_Struc->EalphaNew = _IQ(0.0);
    LBG_Cal_Struc->EalphaPrev = _IQ(0.0);

    LBG_Cal_Struc->EbetaNew = _IQ(0.0);
    LBG_Cal_Struc->EbetaPrev  = _IQ(0.0);

    LBG_Cal_Struc->CalphaNew = _IQ(0.0);
    LBG_Cal_Struc->CalphaPrev = _IQ(0.0);
    LBG_Cal_Struc->CbetaNew = _IQ(0.0);
    LBG_Cal_Struc->CbetaPrev = _IQ(0.0);

    LBG_Cal_Struc->ThetaErr = _IQ(0.0);
    LBG_Cal_Struc->PosiElecPU = _IQ(0.0);
    LBG_Cal_Struc->Angspeed_Inst = _IQ(0.0);
    LBG_Cal_Struc->Angspeed_Aver1 = _IQ(0.0);
    LBG_Cal_Struc->Angspeed_Aver2 = _IQ(0.0);
    LBG_Cal_Struc->Triangle.Cos = _IQ(0.0);
    LBG_Cal_Struc->Triangle.Sin = _IQ(0.0);

    //۲״̬ʼ
    LBGStatus->Overspeed = FALSE;
    LBGStatus->Underspeed = FALSE;
    LBGStatus->Reliable = FALSE;
    LBGStatus->Convergence = FALSE;
    LBGStatus->Timeout = FALSE;
    LBGStatus->Stable = TRUE;

    LBGStatus->Overspeed_CNT =0;
    LBGStatus->Underspeed_CNT = 0;
    LBGStatus->Converged_CNT = 0;
    LBGStatus->Unstable_CNT = 0;

    //໷ʼ
    Speed_PLL_Struc->Error_New = _IQ(0.0);
    Speed_PLL_Struc->Error_Prev = _IQ(0.0);
    Speed_PLL_Struc->Output_New = _IQ(0.0);
    Speed_PLL_Struc->Output_Prev = _IQ(0.0);

    //˲ʼ
    Adaptor->Alpha_Err = _IQ(0.0);
    Adaptor->Alpha_Pre = _IQ(0.0);
    Adaptor->Alpha_New = _IQ(0.0);
    Adaptor->Beta_Err = _IQ(0.0);
    Adaptor->Beta_Pre = _IQ(0.0);
    Adaptor->Beta_New = _IQ(0.0);
}
