/* Define to prevent recursive inclusion ------------------------------------*/
#ifndef __M3_LBG_OBSERVER_H
#define __M3_LBG_OBSERVER_H

/* Includes -----------------------------------------------------------------*/
/* Exported types -----------------------------------------------------------*/
/* Exported constants -------------------------------------------------------*/
#define LBG_CAL_FREQ_M          FREQ_SVPWM  //LBG۲Ƶ(unit-Hz)
#define LBG_K1_CERROR_CURR_M    (-10000)    //LBG۲Ŵ
#define LBG_K2_CERROR_EMF_M     20000       //LBGƹ۲Ŵ

#define LBG_MAX_EMF_M           _IQ(2.0)    //۲ⷴ޷ֵ
#define LBG_MIN_EMF_M           _IQ(-2.0)   //۲ⷴƸ޷ֵ

#define LBG_MAX_CURR_M          _IQ(2.0)    //۲޷ֵ
#define LBG_MIN_CURR_M          _IQ(-2.0)   //۲޷ֵ

#define PLL_KP_M                140     //תٹ۲໷ϵ
#define PLL_KI_M                25148   //תٹ۲໷ϵ

#define LBG_ADAPTOR_ENABLE      0;      //LBG۲۷˲ʹܣ0-ʹܣ1-ʹܣ
#define LBG_ADAPTOR_COEF_M      8000    //LBG۲۷˲ϵ

//#define LBG_SPEED_BUFFERSIZE_M    64    //۲תƽֵ鳤
#define LBG_SPEED_BUFFERSIZE_M    16    //۲תƽֵ鳤

#define LBG_SPEED_MAX_M     _IQ(1.5)    //LBG۲ٶ(unit-rad/s_per)
#define LBG_SPEED_MIN_M     _IQ(0.01)   //LBG۲ٶ(unit-rad/s_per)

#define LBG_OVERSPEED_THRESH_M          _IQ(1.5)    //LBG۲תٳֵ(unit-rad/s_per)
#define LBG_UNDERSPEED_THRESH_M         _IQ(0.05)   //LBG۲תٳֵ(unit-rad/s_per)
#define LBG_OVERSPEED_CNT_THRESH_M      1000        //LBG۲תٳжֵ
#define LBG_UNDERSPEED_CNT_THRESH_M     1000        //LBG۲תٳжֵ

#define LBG_SPEED_VARIANCE_THRESH_M     _IQ(0.125)  //LBG۲תٿɿжֵ

#define LBG_UNSTABLE_CNT_THRESH_M       300         //LBG۲תȶжֵ
#define LBG_UNSTABLE_SPEED_THRESH_M     _IQ(0.02)   //LBG۲תȶжʼжתֵ

#define LBG_CONVERGED_CNT_THRESH_M      300     //LBG۲תжֵ
#define LBG_CONVERGED_UPPER_THRESH_M    _IQ(1.2)//LBG۲תжֵ(unit-PU,0-1)
#define LBG_CONVERGED_LOWER_THRESH_M    _IQ(0.8)//LBG۲תжֵ(unit-PU,0-1)
#define LBG_CONVERGED_EMF_THRESH_M      _IQ(0.5)//LBG۲תƴ(unit-PU,0-1)

#define LBG_STALLBAND_M         _IQ(0.5)//LBG۲ת(unit-rad/s_per)
#define LBG_STALLSPEED_M        _IQ(0.07)//LBG۲תת(unit-rad/s_per)
#define LBG_STALLCURR_M         _IQ(0.9)//LBG۲תж(unit-A_per)
#define LBG_STALL_CNT_THRESH_M  1000    //LBG۲תж,ʱΪתٻ

#define LBG_REVERSE_CNT_THRESH_M    1000        //LBG۲ⷴתжֵ,ʱΪתٻ
#define LBG_REVERSE_SPEED_THRESH_M  _IQ(0.02)   //LBG۲ⷴתжתֵ(unit-rad/s_per)

/* Exported variables -------------------------------------------------------*/
extern LBG_Paramter_Type       LBG_Para_M;      //LBG۲ṹ
extern Speed_PLL_Type          LBG_Speed_PLL_M; //תٹ۲PLLṹ嶨
extern LBG_Cal_Structure_Type  LBG_Cal_M;       //LBG۲ṹ
extern Observer_Adaptor_type   LBG_Adaptor_M;   //LBG۲۷˲ṹ
extern Observer_Status_Type    LBG_Status_M;    //LBG۲״̬ṹ
extern LBG_EMF_Init_Type       LBG_EMF_InitPara_M;      //LBG۲Ƴʼ
extern _iq24 LBG_SpeedBuffer_M[LBG_SPEED_BUFFERSIZE_M];//۲תƽֵ
extern BuffPara_Type LBG_SpeedBuffPara_M;       //۲תƽֵ

/* Exported macro -----------------------------------------------------------*/

/* Exported functions -------------------------------------------------------*/
//LBG۲
void LBG_Parameter_Define (LBG_Paramter_Type *LBG_Para,LBG_Cal_Structure_Type *LBG_Cal_Struc,\
                        BuffPara_Type *BuffPara,Observer_Status_Type *LBGStatus,\
                        Speed_PLL_Type *Speed_PLL_Struc,Observer_Adaptor_type *Adaptor);
//LBG۲
void LBG_Paramter_Cal (Motor_Base_Type *Basestruc,LBG_Paramter_Type *LBG_Para,\
                        LBG_Cal_Structure_Type *LBGCal, Speed_PLL_Type *Speedpll,\
                        BuffPara_Type *BuffPara,LBG_EMF_Init_Type *EMF_InitPara,\
                        Observer_Adaptor_type *Adaptor);
//LBG۲״̬ʼ
void LBG_Status_Init (LBG_Cal_Structure_Type *LBG_Cal_Struc,Speed_PLL_Type *Speed_PLL_Struc,\
                    Observer_Adaptor_type *Adaptor,Observer_Status_Type *LBGStatus);

//LBG۲Ƽʼ
void LBG_EMF_CalInitial(Component_2S_Type *VoltRef_2S,Component_2S_Type *Curr_2S,\
                         _iq24 BusVolt,Motor_IFStart_Type * InjStart,\
                         LBG_Cal_Structure_Type *LBG_Cal_Struc,LBG_EMF_Init_Type *EMF_InitPara);

//LBG۲˲ʼ
void LBG_Adaptor_CalInitial(LBG_Cal_Structure_Type *LBG_Cal_Struc,Observer_Adaptor_type *Adaptor);

//LBG۲תټʼ
void LBG_Speed_CalInitial(LBG_Cal_Structure_Type *LBG_Cal_Struc,_iq24 *Buffer,\
                             Speed_PLL_Type *Speed_PLL_Struc,_iq24 SpeedInial,uint16_t Buffsize);

//LBG۲Ƽ
void LBG_EMF_Cal(Component_2S_Type *VoltRef_2S,Component_2S_Type *Curr_2S,\
                 _iq24 BusVolt,LBG_Cal_Structure_Type *LBG_Cal_Struc,LBG_Paramter_Type *LBG_Para);

//LBG۲תٺͽǶȼ
void LBG_Speed_Posi_Cal(LBG_Cal_Structure_Type *LBG_Cal_Struc,Speed_PLL_Type *Speed_PLL_Struc,\
                        Observer_Adaptor_type *Adaptor);

#endif
