/* Includes------------------------------------------------------------------*/
#include "M0_Control_Library.h"
/* Private typedef ----------------------------------------------------------*/
/* Private define -----------------------------------------------------------*/
/* Private macro ------------------------------------------------------------*/
/* Private functions --------------------------------------------------------*/
/* Private variables --------------------------------------------------------*/
/* variables ----------------------------------------------------------------*/
SVPWM_2R_Type           SVPWM_Cal_M;    //SVPWNṹ
ADC_Structure_Type      ADC_M;          //ADCṹ

/******************************************************************************
* Function Name  : SVPWM_Paramter_Init
* Description    : SVPWMʼ
* Input          : None
* Output         : None
* Return         : None
******************************************************************************/
void SVPWM_Paramter_Init(SVPWM_2R_Type *SVPWM_Cal_Struc,_iq18 Vbase)
{
    //SVPWMģʽ0-BULGE1-HOLLOW;
#if defined SVPWM_BULGE
    SVPWM_Cal_Struc->PWMmode = 0;
#elif defined SVPWM_HOLLOW
    SVPWM_Cal_Struc->PWMmode = 1;
#endif

    //SVPWMڼ
    SVPWM_Cal_Struc->T = ((uint16_t)(TIMER_CLOCK_FREQ_SVPWM/(uint32_t)(FREQ_SVPWM)));
    SVPWM_Cal_Struc->T_IQ18 = (_IQ18(SVPWM_Cal_Struc->T));
    SVPWM_Cal_Struc->HALF_T= SVPWM_Cal_Struc->T/2;
    SVPWM_Cal_Struc->Quard_T = SVPWM_Cal_Struc->T/4;

    //ĸߵѹֵ
    SVPWM_Cal_Struc->BusVolt = _IQ18div(DCBUS_RATED_VOLT,Vbase);

    //ʸʱϵ
    SVPWM_Cal_Struc->coef1 = _IQ18mpy(_IQ18div(SVPWM_Cal_Struc->T_IQ18/2,SVPWM_Cal_Struc->BusVolt),Three_Q18);
    SVPWM_Cal_Struc->coef2 = _IQ18mpy(_IQ18div(SVPWM_Cal_Struc->T_IQ18/2,SVPWM_Cal_Struc->BusVolt),SQRT3_Q18);
}

/******************************************************************************
* Function Name  : SVPWM_Status_Initial_M
* Description    : SVPWM״̬ʼ
* Input          : SVPWMṹ壬ʹöʱָ
* Output         : None
* Return         : None
******************************************************************************/
void SVPWM_Status_Initial_M(SVPWM_2R_Type *SVPWM_Cal_Struc,TIM_TypeDef *Timer)
{
    //PWMĶʱͨȽֵֵ
    Timer->CH1CVR = SVPWM_Cal_Struc->Quard_T;
    Timer->CH2CVR = SVPWM_Cal_Struc->Quard_T;
    Timer->CH3CVR = SVPWM_Cal_Struc->Quard_T;

    //SVPWMļֵ
    SVPWM_Cal_Struc->cc1 = SVPWM_Cal_Struc->Quard_T;
    SVPWM_Cal_Struc->cc2 = SVPWM_Cal_Struc->Quard_T;
    SVPWM_Cal_Struc->cc3 = SVPWM_Cal_Struc->Quard_T;
    SVPWM_Cal_Struc->cc1Load = SVPWM_Cal_Struc->Quard_T;
    SVPWM_Cal_Struc->cc2Load = SVPWM_Cal_Struc->Quard_T;
    SVPWM_Cal_Struc->cc3Load = SVPWM_Cal_Struc->Quard_T;

#if defined SVPWM_BULGE
    SVPWM_Cal_Struc->cc4Load = 1;
#elif defined SVPWM_HOLLOW
    SVPWM_Cal_Struc->cc4Load = SVPWM_Cal_Struc->HALF_T-1;
#endif

    SVPWM_Cal_Struc->sector = 1;
    SVPWM_Cal_Struc->VoltLimMark = 0;
}
/******************************************************************************
* Function Name  : ADC_Parameter_Init
* Description    : ADC
* Input          : ADCṹָ
* Output         : None
* Return         : None
******************************************************************************/
void ADC_Parameter_Init (ADC_Structure_Type *ADCStruc,_iq18 Ibase)
{
    //ӦĲֵ
    ADCStruc->RatedCurr_ConvInv = _IQ16mpyIQX(_IQ16div(_IQ16(128),_IQ16(32767)),\
                            16,_IQ18div(CURR_SAMPLE_RANGE_ADC,Ibase),18);

    //ѹӦĲֵ
    ADCStruc->DCVoltRatedADC = _IQ18div(_IQ18mpy(DCBUS_CONV_RATIO,DCBUS_RATED_VOLT),_IQ18(3.3))*4096;

    //ѹӦĲֵ
    ADCStruc->DCVoltRatedADCInv =_IQ18div(_IQ18(1.0),ADCStruc->DCVoltRatedADC);

    //ѹƽֵϵ
    ADCStruc->DCVoltAverSizeInv1 = _IQ18div(_IQ18(1.0),_IQ18(DCBUS_VOLT_AVER_SIZE));
    ADCStruc->DCVoltAverSizeInv2 = _IQ18(1.0)-ADCStruc->DCVoltAverSizeInv1;
}

/******************************************************************************
* Function Name  : ADC_Status_Init
* Description    : ADC״̬ʼ
* Input          : ADCṹָ롢ADCĴָ룬ʱָ
* Output         : None
* Return         : None
******************************************************************************/
void ADC_Status_Init (ADC_Structure_Type *ADCStruc,ADC_TypeDef *ADCx,TIM_TypeDef *Timer)
{
    Timer->CH4CVR = 1;//תȽֵ

    ADC_M.AdcChannel = CURR_CHANNEL_PHASEA_M; //ADCֵͨ
    ADC_M.AdcChanne2 = CURR_CHANNEL_PHASEB_M; //ADCֵͨ

    ADCx->ISQR = PHASE_A_JQ3 + PHASE_B_JQ4 + INJ_CONVERT_LENGTH_ADC;//עת

    //ĸߵѹֵ
    ADCStruc->DCVoltPres = DCBUS_VOLT_AVER_INIT;
    ADCStruc->DCVoltAver = DCBUS_VOLT_AVER_INIT;
}

/******************************************************************************
* Function Name  : SVPWM_Timer_Configure
* Description    : SVPWM˿ڡʱʼ
* Input          : None
* Output         : None
* Return         : None
******************************************************************************/
void SVPWM_Timer_Configure(TIM_TypeDef *Timer)
{
    // üĴṹ嶨
    TIM_TimeBaseInitTypeDef TIM_TimeBaseStructure={0};
    TIM_OCInitTypeDef TIM_OCInitStructure={0};
    TIM_BDTRInitTypeDef TIM_BDTRInitStructure={0};
    GPIO_InitTypeDef GPIO_InitStructure={0};

    //ʱ
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA | RCC_APB2Periph_GPIOB\
                          | RCC_APB2Periph_AFIO | RCC_APB2Periph_TIM1, ENABLE);

    //PWMIO
    GPIO_StructInit(&GPIO_InitStructure);
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_8 | GPIO_Pin_9 | GPIO_Pin_10  ;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(GPIOA, &GPIO_InitStructure);
    GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_12|GPIO_Pin_13 | GPIO_Pin_14 | GPIO_Pin_15;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(GPIOB, &GPIO_InitStructure);//üĴʵ
    GPIO_ResetBits(GPIOB,GPIO_Pin_12);

    //ʱ1
    TIM_DeInit(Timer);//ʱĴλ

    //ڳʼʱṹĳʼ
    TIM_TimeBaseStructInit(&TIM_TimeBaseStructure);

    //ԤƵ
    TIM_TimeBaseStructure.TIM_Prescaler = TIMER_PRESCALER_SVPWM;

    //ģʽ
    TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_CenterAligned1;

    //
    TIM_TimeBaseStructure.TIM_Period = SVPWM_Cal_M.HALF_T;

    //˲Ƶ2Ƶ
    TIM_TimeBaseStructure.TIM_ClockDivision = TIM_CKD_DIV2;

    //¼
    TIM_TimeBaseStructure.TIM_RepetitionCounter = TIMER_UPDATE_RATE_SVPWM;

    //üĴʵ
    TIM_TimeBaseInit(Timer, &TIM_TimeBaseStructure);

    //Ƚʼýṹĳʼ
    TIM_OCStructInit(&TIM_OCInitStructure);

#if defined SVPWM_BULGE
    TIM_OCInitStructure.TIM_OCMode = TIM_OCMode_PWM2;//ڱȽϼĴֵΪЧΪЧ
#elif defined SVPWM_HOLLOW
    TIM_OCInitStructure.TIM_OCMode = TIM_OCMode_PWM1;//СڱȽϼĴֵΪЧΪЧ
#endif

    //ͨȽʹ
    TIM_OCInitStructure.TIM_OutputState = TIM_OutputState_Enable;

    //ͨȽʹ
    TIM_OCInitStructure.TIM_OutputNState = TIM_OutputNState_Enable;

    //dummy value
    TIM_OCInitStructure.TIM_Pulse = SVPWM_Cal_M.HALF_T/2;

    //ͨȽߵƽЧ
    TIM_OCInitStructure.TIM_OCPolarity = TIM_OCPolarity_High;

    //ͨȽ͵ƽЧ
    TIM_OCInitStructure.TIM_OCNPolarity = TIM_OCNPolarity_High;//PUԤ

    //ͨ״̬Ϊ͵ƽ
    TIM_OCInitStructure.TIM_OCIdleState = TIM_OCIdleState_Reset;

    //ͨ״̬Ϊ͵ƽ
    TIM_OCInitStructure.TIM_OCNIdleState = TIM_OCNIdleState_Reset;//PUԤ

    TIM_OC1Init(Timer, &TIM_OCInitStructure);//Ƚͨ1ʼ
    TIM_OC2Init(Timer, &TIM_OCInitStructure);//Ƚͨ2ʼ
    TIM_OC3Init(Timer, &TIM_OCInitStructure);//Ƚͨ3ʼ

    //ʹtimer1·ȽԤع
    TIM_OC1PreloadConfig(Timer, TIM_OCPreload_Enable);//ʹܲȽͨ1Ԥװ
    TIM_OC2PreloadConfig(Timer, TIM_OCPreload_Enable);//ʹܲȽͨ1Ԥװ
    TIM_OC3PreloadConfig(Timer, TIM_OCPreload_Enable);//ʹܲȽͨ1Ԥװ

    //ɲ
    TIM_BDTRInitStructure.TIM_OSSRState = TIM_OSSRState_Enable;//OSSRʹ
    TIM_BDTRInitStructure.TIM_OSSIState = TIM_OSSIState_Enable;//OSSIʹ

    //ĴΪ1
    TIM_BDTRInitStructure.TIM_LOCKLevel = TIM_LOCKLevel_1;

    //ʱ
    TIM_BDTRInitStructure.TIM_DeadTime = DEADTIME_CLOCK_SVPWM;

    TIM_BDTRInitStructure.TIM_Break = TIM_Break_Enable;//ɲʹ

    //ɲźżΪЧ
    TIM_BDTRInitStructure.TIM_BreakPolarity = TIM_BreakPolarity_High;

    //Զֹ
    TIM_BDTRInitStructure.TIM_AutomaticOutput = TIM_AutomaticOutput_Disable;

    //üĴʵ
    TIM_BDTRConfig(Timer, &TIM_BDTRInitStructure);

    //ж
    TIM_SelectOutputTrigger(Timer, TIM_TRGOSource_Update);//ѡ¼ΪⲿԴ
    TIM_SetCounter(Timer,0);                    //ʱ
    TIM_ClearFlag(Timer, TIM_FLAG_Update);      //¼жϱ־
    TIM_ITConfig(Timer, TIM_IT_Update, ENABLE); //ʹܸ¼ж
}

/******************************************************************************
* Function Name  : ADC_Configure
* Description    : ADC
* Input          : ADCṹָ롢ʱָ
* Output         : None
* Return         : None
******************************************************************************/
void ADC_Configure(ADC_Structure_Type *ADCStruc,ADC_TypeDef *ADCx,TIM_TypeDef *Timer)
{
    // üĴṹ嶨
    ADC_InitTypeDef ADC_InitStructure={0};
    GPIO_InitTypeDef GPIO_InitStructure={0};
    TIM_OCInitTypeDef Timer_OCInitStructure={0};

    //ʱ
    RCC_ADCCLKConfig(RCC_PCLK2_Div6);//ADCʱΪPCLK2Ƶ

    //ʱʹ
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA|RCC_APB2Periph_GPIOB\
                           |RCC_APB2Periph_AFIO | RCC_APB2Periph_ADC1\
                           | RCC_APB2Periph_ADC2, ENABLE);

    // ADC
    GPIO_StructInit(&GPIO_InitStructure);
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_2|GPIO_Pin_4|GPIO_Pin_5|GPIO_Pin_7;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AIN;
    GPIO_Init(GPIOA, &GPIO_InitStructure);

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0|GPIO_Pin_1;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AIN;
    GPIO_Init(GPIOB, &GPIO_InitStructure);

    //Ƚ
    TIM_OCStructInit(&Timer_OCInitStructure);

#if defined SVPWM_BULGE
    Timer_OCInitStructure.TIM_OCMode = TIM_OCMode_PWM1;
    Timer_OCInitStructure.TIM_Pulse = 1;
#elif defined SVPWM_HOLLOW
    Timer_OCInitStructure.TIM_OCMode = TIM_OCMode_PWM2;
    Timer_OCInitStructure.TIM_Pulse = SVPWM_Cal_M.HALF_T-1;
#endif

    //ͨȽʹ
    Timer_OCInitStructure.TIM_OutputState = TIM_OutputState_Enable;

    //ͨȽֹ
    Timer_OCInitStructure.TIM_OutputNState = TIM_OutputNState_Disable;

    //ͨ߱ȽߵƽЧ
    Timer_OCInitStructure.TIM_OCPolarity = TIM_OCPolarity_High;

    //ͨȽ͵ƽЧ
    Timer_OCInitStructure.TIM_OCNPolarity =TIM_OCNPolarity_Low;

    //ͨ״̬Ϊ͵ƽ
    Timer_OCInitStructure.TIM_OCIdleState = TIM_OCIdleState_Reset;

    //ͨ״̬Ϊƽ
    Timer_OCInitStructure.TIM_OCNIdleState = TIM_OCIdleState_Reset;

    TIM_OC4Init(Timer, &Timer_OCInitStructure);         //üĴʵ
    TIM_OC4PreloadConfig(Timer, TIM_OCPreload_Enable);  //ʹܲȽͨ4Ԥװ
    TIM_ITConfig(Timer, TIM_IT_CC4,DISABLE);            //ֹȽ4ж

    ADC_DeInit(ADCx);                                   //ADCĴλ
    ADC_StructInit(&ADC_InitStructure);                 //ADʼýṹĳʼ
    ADC_InitStructure.ADC_Mode = ADC_Mode_InjecSimult;  //ѡͬעģʽ
    ADC_InitStructure.ADC_ScanConvMode = ENABLE;        //ɨʹ
    ADC_InitStructure.ADC_ContinuousConvMode = DISABLE; //תֹ
    ADC_InitStructure.ADC_ExternalTrigConv = ADC_ExternalTrigConv_None;//ת
    ADC_InitStructure.ADC_DataAlign = ADC_DataAlign_Left;//ݲģʽ
    ADC_InitStructure.ADC_NbrOfChannel = 1;             //תͨΪ1
    ADC_Init(ADCx, &ADC_InitStructure);                 //üĴʵ

    //ãĸߵѹ
    ADC_RegularChannelConfig(ADCx,ADC_Channel_2, 1, SAMPLING_TIMER_CLOCK );

    ADC_Cmd(ADCx, ENABLE); //ADCʹ

    //ADCУ׼
    ADC_ResetCalibration(ADCx);
    while(ADC_GetResetCalibrationStatus(ADCx));
    ADC_StartCalibration(ADCx);
    while(ADC_GetCalibrationStatus(ADCx));
}

/******************************************************************************
* Function Name  : SVPWM_Calculation
* Description    : SVPWM
* Input          : SVPWMṹָ룬ྲֹϵѹָ룬ʱָ
* Output         : None
* Return         : None
******************************************************************************/
void  SVPWM_Calculation (SVPWM_2R_Type *SVPWM_Cal, Component_2S_Type *VoltRef,TIM_TypeDef *Timer)
{
    _iq18 hUalpha_coef1,hUbeta_coef2;   //ྲֹϵѹʱ

    hUalpha_coef1 = _IQ18MPY_MACRO(SVPWM_Cal->coef1, VoltRef->Alpha>>6);
    hUbeta_coef2 = _IQ18MPY_MACRO(SVPWM_Cal->coef2, VoltRef->Beta>>6);

    SVPWM_Cal->hx = hUbeta_coef2 * 2;
    SVPWM_Cal->hy = hUalpha_coef1 + hUbeta_coef2;
    SVPWM_Cal->hz = hUbeta_coef2 - hUalpha_coef1;

    //ж
    if(SVPWM_Cal->hx > 0)
    {
        if((-SVPWM_Cal->hz) > 0)
            SVPWM_Cal->sector = 1;
        else
        {
            if((-SVPWM_Cal->hy)>= 0)
                SVPWM_Cal->sector = 3;
            else
                SVPWM_Cal->sector = 2;
        }
    }
    else
    {
        if((-SVPWM_Cal->hz) <= 0)
            SVPWM_Cal->sector = 4;
        else
        {
            if((-SVPWM_Cal->hy)>= 0)
                SVPWM_Cal->sector= 5;
            else
                SVPWM_Cal->sector = 6;
        }
    }

    //ͬʸʱ
    switch(SVPWM_Cal->sector)
    {
        case 1:
                SVPWM_Cal->ht1 = -SVPWM_Cal->hz;//t1=-z
                SVPWM_Cal->ht2 = SVPWM_Cal->hx;//t2 =x
                break;
        case 2:
                SVPWM_Cal->ht1 = SVPWM_Cal->hz;
                SVPWM_Cal->ht2 = SVPWM_Cal->hy;
                break;
        case 3:
                SVPWM_Cal->ht1 = SVPWM_Cal->hx;
                SVPWM_Cal->ht2 = -SVPWM_Cal->hy;
                break;
        case 4:
                SVPWM_Cal->ht1 = -SVPWM_Cal->hx;
                SVPWM_Cal->ht2 = SVPWM_Cal->hz;
                break;
        case 5:
                SVPWM_Cal->ht1 = -SVPWM_Cal->hy;
                SVPWM_Cal->ht2 = -SVPWM_Cal->hz;
                break;
        case 6:
                SVPWM_Cal->ht1 = SVPWM_Cal->hy;
                SVPWM_Cal->ht2 = -SVPWM_Cal->hx;
                break;
    }

#if defined SVPWM_BULGE
        //ͨñȽֵļ
        SVPWM_Cal->cc1 = SVPWM_Cal->Quard_T + (u16)(SVPWM_Cal->ht1>>20) + (u16)(SVPWM_Cal->ht2>>20);//T/4+Tx/4+Ty/4 = (T+TX+TY)/4
        SVPWM_Cal->cc2 = SVPWM_Cal->cc1 - (u16)(SVPWM_Cal->ht2>>19);    //(T+TX+TY)/4-TY/2 = (T+TX-TY)/4
        SVPWM_Cal->cc3 = SVPWM_Cal->cc2 - (u16)(SVPWM_Cal->ht1>>19);//(T+TX-TY)/4-TX/2 = (T-TX-TY)/4

        //ͬװرȽֵķ
        switch(SVPWM_Cal->sector)
        {
            case 1:
                    SVPWM_Cal->cc1Load = SVPWM_Cal->cc3;
                    SVPWM_Cal->cc2Load = SVPWM_Cal->cc2;
                    SVPWM_Cal->cc3Load = SVPWM_Cal->cc1;
                    break;
            case 2:
                    SVPWM_Cal->cc1Load = SVPWM_Cal->cc2;
                    SVPWM_Cal->cc2Load = SVPWM_Cal->cc3;
                    SVPWM_Cal->cc3Load = SVPWM_Cal->cc1;
                    break;
            case 3:
                    SVPWM_Cal->cc1Load = SVPWM_Cal->cc1;
                    SVPWM_Cal->cc2Load = SVPWM_Cal->cc3;
                    SVPWM_Cal->cc3Load = SVPWM_Cal->cc2;
                    break;
            case 4:
                    SVPWM_Cal->cc1Load = SVPWM_Cal->cc1;
                    SVPWM_Cal->cc2Load = SVPWM_Cal->cc2;
                    SVPWM_Cal->cc3Load = SVPWM_Cal->cc3;
                    break;
            case 5:
                    SVPWM_Cal->cc1Load = SVPWM_Cal->cc2;
                    SVPWM_Cal->cc2Load = SVPWM_Cal->cc1;
                    SVPWM_Cal->cc3Load = SVPWM_Cal->cc3;
                    break;
            case 6:
                    SVPWM_Cal->cc1Load = SVPWM_Cal->cc3;
                    SVPWM_Cal->cc2Load = SVPWM_Cal->cc1;
                    SVPWM_Cal->cc3Load = SVPWM_Cal->cc2;
                    break;
            default:
                   break;
        }
#elif defined SVPWM_HOLLOW
        //ͨñȽֵļ
        SVPWM_Cal->cc1 = SVPWM_Cal->Quard_T + (u16)(SVPWM_Cal->ht1>>20) + (u16)(SVPWM_Cal->ht2>>20);//T/4+Tx/4+Ty/4=(T+TX+TY)/4
        SVPWM_Cal->cc2 = SVPWM_Cal->cc1 - (u16)(SVPWM_Cal->ht1>>19);//(T+TX+TY)/4-TX/2=(T-TX+TY)/4
        SVPWM_Cal->cc3 = SVPWM_Cal->cc2 - (u16)(SVPWM_Cal->ht2>>19);////(T+TX+TY)/4-TY/2=(T-TX-TY)/4

        //ͬװرȽֵķ
        switch(SVPWM_Cal->sector)
        {
           case 1:
                   SVPWM_Cal->cc1Load = SVPWM_Cal->cc1;
                   SVPWM_Cal->cc2Load = SVPWM_Cal->cc2;
                   SVPWM_Cal->cc3Load = SVPWM_Cal->cc3;
                   break;
           case 2:
                   SVPWM_Cal->cc1Load = SVPWM_Cal->cc2;
                   SVPWM_Cal->cc2Load = SVPWM_Cal->cc1;
                   SVPWM_Cal->cc3Load = SVPWM_Cal->cc3;
                   break;
           case 3:
                   SVPWM_Cal->cc1Load = SVPWM_Cal->cc3;
                   SVPWM_Cal->cc2Load = SVPWM_Cal->cc1;
                   SVPWM_Cal->cc3Load = SVPWM_Cal->cc2;
                   break;
           case 4:
                   SVPWM_Cal->cc1Load = SVPWM_Cal->cc3;
                   SVPWM_Cal->cc2Load = SVPWM_Cal->cc2;
                   SVPWM_Cal->cc3Load = SVPWM_Cal->cc1;
                    break;
           case 5:
                   SVPWM_Cal->cc1Load = SVPWM_Cal->cc2;
                   SVPWM_Cal->cc2Load = SVPWM_Cal->cc3;
                   SVPWM_Cal->cc3Load = SVPWM_Cal->cc1;
                   break;
           case 6:
                   SVPWM_Cal->cc1Load = SVPWM_Cal->cc1;
                   SVPWM_Cal->cc2Load = SVPWM_Cal->cc3;
                   SVPWM_Cal->cc3Load = SVPWM_Cal->cc2;
                   break;
           default:
                  break;
        }
#endif

//Ƚװ
    Timer->CH1CVR = SVPWM_Cal->cc1Load;
    Timer->CH2CVR = SVPWM_Cal->cc2Load;
    Timer->CH3CVR = SVPWM_Cal->cc3Load;
}
/******************************************************************************
* Function Name  : ADC_Trigger
* Description    : ADCʱ̼
* Input          : SVPWMṹָ룬ADCĴָ룬ʱָ
* Output         : None
* Return         : None
******************************************************************************/
void ADC_Trigger(SVPWM_2R_Type *SVPWM_Cal,ADC_TypeDef *ADCx,TIM_TypeDef *Timer)
{
    #if defined SVPWM_BULGE
        SVPWM_Cal->cc4Load = 1;
    #elif defined SVPWM_HOLLOW
        SVPWM_Cal->cc4Load = SVPWM_Cal->HALF_T-1;
    #endif

    ADCx->ISQR = PHASE_A_JQ3 + PHASE_B_JQ4 + INJ_CONVERT_LENGTH_ADC;
    Timer->CH4CVR = SVPWM_Cal->cc4Load;
}

/******************************************************************************
* Function Name  : Current_Cal_2R
* Description    : ȡ
* Input          : ADCṹָ룬ADCĴָ
* Output         : None
* Return         : None
******************************************************************************/
Component_3S_Type Current_Cal_2R(ADC_Structure_Type *ADCStruc,ADC_TypeDef *ADCx)
{
    Component_3S_Type  Local_Stat_Curr;     //ֲṹ嶨
    int32_t ADsample_read1;                     //ADƫüADֵ
    int16_t ADsample_int1;                      //޷ADֵ
    int32_t ADsample_read2;                     //ADƫüADֵ
    int16_t ADsample_int2;                      //޷ADֵ

    ADsample_read1=(ADCx->IDATAR1<<1);      //ȡת1

    //ADCת1תΪֵ޷
    ADsample_read1 =(int32_t)(ADCStruc->OffsetValue_A)-ADsample_read1;
    if (ADsample_read1> S16_MAX)
       ADsample_int1 = S16_MAX;
    else if (ADsample_read1 < S16_MIN)
       ADsample_int1 = S16_MIN;
    else
       ADsample_int1 = ADsample_read1;

    ADsample_read2=(ADCx->IDATAR2<<1);      //ȡת2

    //ADCת1תΪֵ޷
    ADsample_read2 = (int32_t)(ADCStruc->OffsetValue_B)-ADsample_read2;
    if (ADsample_read2> S16_MAX)
       ADsample_int2 = S16_MAX;
    else if (ADsample_read2 < S16_MIN)
       ADsample_int2 = S16_MIN;
    else
       ADsample_int2 = ADsample_read2;

    //IA
    Local_Stat_Curr.PhaseA = _IQ16toIQ((_IQ16MPY_MACRO(_IQ16(ADsample_int1),\
                                       ADCStruc->RatedCurr_ConvInv))>>7);//ϵ128ŴҪ

    //IB
    Local_Stat_Curr.PhaseB = _IQ16toIQ((_IQ16MPY_MACRO(_IQ16(ADsample_int2),\
                                       ADCStruc->RatedCurr_ConvInv))>>7);//ϵ128ŴҪ

   //ICIC = -IA-IB
    Local_Stat_Curr.PhaseC = -(Local_Stat_Curr.PhaseA + Local_Stat_Curr.PhaseB);

    return(Local_Stat_Curr);
}

/******************************************************************************
* Function Name  : DCBUS_Volt_Cal
* Description    : ĸߵѹ
* Input          : ADCṹָ룬ADCĴָ
* Output         : None
* Return         : None
******************************************************************************/
void DCBUS_Volt_Cal(ADC_Structure_Type *ADCStruc,ADC_TypeDef *ADCx)
{
    //ȡǰĸߵѹ
    ADCStruc->DCVoltPres=_IQ18MPY_MACRO(_IQ18(ADCx->RDATAR>>4),ADCStruc->DCVoltRatedADCInv);

    //ֵ
    ADCStruc->DCVoltAver = _IQ18MPY_MACRO(ADCStruc->DCVoltAver,ADCStruc->DCVoltAverSizeInv2)\
                            + _IQ18MPY_MACRO(ADCStruc->DCVoltPres,ADCStruc->DCVoltAverSizeInv1);
}

/******************************************************************************
* Function Name  : ADC_Offset_Reading
* Description    : ADƫȡ
* Input          : ADCĴָ룬ADCṹָ
* Output         : None
* Return         : None
******************************************************************************/
void ADC_Offset_Reading(ADC_TypeDef *ADCx, ADC_Structure_Type *ADCStruc)
{
    uint16_t i;

    ADCStruc->OffsetValue_A = 0;//Aͨƫóʼ
    ADCStruc->OffsetValue_B = 0;//Bͨƫóʼ

    //ֹԶעͨתֹעж
    ADC_ITConfig(ADCx, ADC_IT_JEOC, DISABLE);

    //עתⲿԴΪ
    ADC_ExternalTrigInjectedConvConfig(ADCx, ADC_ExternalTrigInjecConv_None);

    //ʹⲿ¼עת
    ADC_ExternalTrigInjectedConvCmd(ADCx,ENABLE);

    //עתΪ2
    ADC_InjectedSequencerLengthConfig(ADCx,2);

    //AΪ1ʱΪSAMPLING_TIME_CK
    ADC_InjectedChannelConfig(ADCx, ADCStruc->AdcChannel,1,SAMPLING_TIMER_CLOCK);

    //BΪ2ʱΪSAMPLING_TIME_CK
    ADC_InjectedChannelConfig(ADCx, ADCStruc->AdcChanne2,2,SAMPLING_TIMER_CLOCK);

    ADC_ClearFlag(ADCx, ADC_FLAG_JEOC);//עת־λ

    ADC_SoftwareStartInjectedConvCmd(ADCx,ENABLE);//עת

    //ۼ16Σ4λʵעת(͹һ)
    for(i=0; i <CURR_OFFSET_READ_NUM_ADC; i++)
    {
       while(!ADC_GetFlagStatus(ADCx,ADC_FLAG_JEOC));//ȴעת

       //3λۼ
       ADCStruc->OffsetValue_A += (ADC_GetInjectedConversionValue(ADCx,ADC_InjectedChannel_1)>>3);
       ADCStruc->OffsetValue_B += (ADC_GetInjectedConversionValue(ADCx,ADC_InjectedChannel_2)>>3);

       ADC_ClearFlag(ADCx, ADC_FLAG_JEOC);//עת־λ
       ADC_SoftwareStartInjectedConvCmd(ADCx,ENABLE);//ٴ
    }

    //ⲿԴΪT1TRGO---ԤʱĳT1CC4
    ADC_ExternalTrigInjectedConvConfig(ADCx, ADC_ExternalTrigInjecConv_T1_TRGO);

    //ʹעⲿ
    ADC_ExternalTrigInjectedConvCmd(ADCx,ENABLE);

    //ʹעתж
    ADC_ITConfig(ADCx, ADC_IT_JEOC, ENABLE);
}

/******************************************************************************
* Function Name  : ADC_Start
* Description    : ADCת
* Input          : ʹADCĴָ
* Output         : None
* Return         : None
******************************************************************************/
void ADC_Start (FunctionalState cmd,ADC_TypeDef *ADCx)
{
    if (cmd == ENABLE)
    {
        //ADC1ⲿԴΪT1CC4
        ADC_ExternalTrigInjectedConvConfig(ADCx, ADC_ExternalTrigInjecConv_T1_CC4);
    }
    else
    {
        //T1CC4ΪעתĴԴ
        ADCx->CTLR2 &=0xFFFFEFFF;

        //ⲿԴΪT1TRGOʱĳT1CC4
        ADC_ExternalTrigInjectedConvConfig(ADCx, ADC_ExternalTrigInjecConv_T1_TRGO);
    }
}
