/* Includes -----------------------------------------------------------------*/
#include "M0_Control_Library.h"

/* Private typedef ----------------------------------------------------------*/
/* Private define -----------------------------------------------------------*/
/* Private macro ------------------------------------------------------------*/
/* Private functions --------------------------------------------------------*/
/* Private variables --------------------------------------------------------*/

/* Variables ----------------------------------------------------------------*/
Motor_IFStart_Type InjStart_M;          //ƽṹ

/******************************************************************************
* Function Name  : Motor_Start_Init
* Description    : ǰĳʼ
* Input          : None
* Output         : None
* Return         : None
******************************************************************************/
void Motor_Start_Init_M(void)
{
    Speed_Initial();

    PID_Output_Init(&SpeedRegStruc_M,&dCurrRegStruc_M,&qCurrRegStruc_M); //PIDʼ

    Motor_Status_Initial_M(); //״̬ͼʼ

    Injection_Startup_Status_Init_M(); //ջʼ

    //Dʼ
    Dcurr_Process_Init(&DCurrProcess_M,DAXIS_CURR_REF_INIT_M,\
                        DAXIS_CURR_WEAK_SPEED_M,DAXIS_CURR_REF_STEP_M);

    SVPWM_Status_Initial_M(&SVPWM_Cal_M,TIM1);//SVPWM״̬ʼ

    ADC_Status_Init (&ADC_M,ADC1,TIM1);       //ADC״̬ʼ

    LBG_Status_Init(&LBG_Cal_M,&LBG_Speed_PLL_M,&LBG_Adaptor_M,&LBG_Status_M); //LBG۲ʼ

    Buffer_Clear(&(LBG_SpeedBuffer_M[0]),&LBG_SpeedBuffPara_M);//LBG۲תʼ

    ADC_Offset_Reading(ADC1,&ADC_M); //ƫöȡ

    SVPWM_Calculation(&SVPWM_Cal_M,&StatVoltRef2S_M,TIM1);//Ծٵݳ

    TIM_CtrlPWMOutputs(TIM1,ENABLE); //ʹܶʱPWM

    Time_Wait_500us(8);  //ӳ4ms

    SVPWM_Status_Initial_M(&SVPWM_Cal_M,TIM1);//SVPWM״̬ʼ

    ADC_Start(ENABLE,ADC1);//ADCתʹ
}
/******************************************************************************
* Function Name  : Injection_Startup_Para_Init
* Description    : עʼ
* Input          : None
* Output         : None
* Return         : None
******************************************************************************/
void Injection_Startup_Para_Init_M (void)
{
    //λ׶εֵ
    InjStart_M.ForceInjCurrStep = _IQdiv(FORCE_INJ_CURR_M,FORCE_INJ_CURR_RAMP_TIME_M)/FORCE_INJ_FREQ_M;

    //λ׶εĿֵֵ
    InjStart_M.ForceInjCurrTarget = FORCE_INJ_CURR_M;

    //λ׶εǶȸֵ
    InjStart_M.ForceInjCurrAngle = FORCE_INJ_ANGLE1_M;

    //λ׶θֵ
    InjStart_M.ForceInjStage = RAMP_INJ_STAGE_M;

    //ջĿֵֵ
    InjStart_M.RampInjCurrTarget = RAMP_INJ_CURR_FINAL_M;

    //ջֵ
    InjStart_M.RampInjCurrStep = _IQdiv((RAMP_INJ_CURR_FINAL_M - RAMP_INJ_CURR_INIT_M),\
                                  RAMP_INJ_CURR_RAMP_TIME_M)/RAMP_INJ_FREQ_M;

    //ջתٸֵ
    InjStart_M.RampInjSpeedTarget = RAMP_INJ_SPEED1_M*STARTUP_DIRECTION;

    //ջת1ֵ
    InjStart_M.RampInjSpeedStep1 = _IQdiv(RAMP_INJ_SPEED1_M,RAMP_INJ_SPEED_RAMP_TIME1_M)/RAMP_INJ_FREQ_M;

    //ջת2ֵ
    InjStart_M.RampInjSpeedStep2 = _IQdiv(RAMP_INJ_SPEED2_M,RAMP_INJ_SPEED_RAMP_TIME2_M)/RAMP_INJ_FREQ_M;

    //ջתתΪǶȼϵ
    InjStart_M.K_WetoPosi = RAMP_INJ_PERIOD_M*RATED_FREQ_M;

    //ջжֵ
    InjStart_M.CurrErrThresh = INJECTION_CURRERR_THRESH_M;

    //ջ׶θֵ
    InjStart_M.RampInjStage1 = RAMP_INJ_STAGE1_M;
    InjStart_M.RampInjStage2 = RAMP_INJ_STAGE2_M;
}

/******************************************************************************
* Function Name  : Injection_Startup_Status_Init_M
* Description    : ע״̬ʼ
* Input          : None
* Output         : None
* Return         : None
******************************************************************************/
void Injection_Startup_Status_Init_M(void)
{
    InjStart_M.ForceInjCurrRef = _IQ(0);                        //ǿע
    InjStart_M.ForceInjCounter = 0;                             //ǿעֵ

    InjStart_M.RampInjCurrRef = RAMP_INJ_CURR_INIT_M;           //ջֵ
    InjStart_M.RampInjSpeedRef = _IQ(0);                        //ջת
    InjStart_M.RampInjSpeedStep = InjStart_M.RampInjSpeedStep1; //ջתֵ
    InjStart_M.RampInjAngle = _IQ(0);                           //ջǶ
    InjStart_M.RampInjCounter =0;                               //ջʱ
    InjStart_M.Curr_2R.cd = _IQ(0);                             //ջ׶ι۲d
    InjStart_M.Curr_2R.cq = _IQ(0);                             //ջ׶ι۲q
    InjStart_M.VoltRef_2R.cd = _IQ(0);                          //ջ׶ι۲dѹ
    InjStart_M.VoltRef_2R.cq = _IQ(0);                          //ջ׶ι۲qѹ
    InjStart_M.Status = INITIAL;                                //״̬λΪʼ״̬
}

/******************************************************************************
* Function Name  : Injection_Startup_M
* Description    : עǿƶλȻջ.
* Input          : None
* Output         : None
* Return         : None
******************************************************************************/
void Injection_Startup_M(void)
{
    switch(InjStart_M.Status)//״̬
      {
        case INITIAL://ʼݺ͵ջϲ
             InjStart_M.Status = INJECTION;
            break;

        case INJECTION://ǿƶλĴ

            if(InjStart_M.ForceInjCounter < U32_MAX)
                InjStart_M.ForceInjCounter++;//ջʱ

            if(InjStart_M.ForceInjCurrRef < InjStart_M.ForceInjCurrTarget)
            {
                //λ׶Σע
                InjStart_M.ForceInjCurrRef += InjStart_M.ForceInjCurrStep;
                if(InjStart_M.ForceInjCurrRef > InjStart_M.ForceInjCurrTarget)
                    InjStart_M.ForceInjCurrRef = InjStart_M.ForceInjCurrTarget;

                StatCurrRef2R_M.cd = InjStart_M.ForceInjCurrRef; //dֵ
                StatCurrRef2R_M.cq = 0;                         //q0

                //עǶȼ
                Struct_Cossin_M = TrigonoMetric_Function( InjStart_M.ForceInjCurrAngle);
            }
            else//λɺʼλصı
            {
                if( _IQabs(StatCurr2R_M.cd)>=_IQMPY_MACRO(InjStart_M.CurrErrThresh,\
                     _IQabs(StatCurrRef2R_M.cd)))
                {
                    if( InjStart_M.ForceInjCounter >= InjStart_M.ForceInjStage)
                    {
                        InjStart_M.RampInjCurrRef = InjStart_M.ForceInjCurrRef; //ջʼ
                        InjStart_M.RampInjAngle = InjStart_M.ForceInjCurrAngle; //ջǶȳʼ
                        InjStart_M.Status = RAMP;                               //״̬л
                    }
                }
                else
                {
                    Protection_SetFault(STARTUP_FAILURE_M); //ʼսϴжΪʧ
                    printf("Motor_StartFailure=%d\r\n",1111);
                }
           }

            break;

        case RAMP:
            if(InjStart_M.RampInjCounter < U32_MAX)
                InjStart_M.RampInjCounter++;//ջʱ

            //лƵ
            if (InjStart_M.RampInjCounter == InjStart_M.RampInjStage1)
            {
                InjStart_M.RampInjSpeedTarget = RAMP_INJ_SPEED2_M*STARTUP_DIRECTION;
                InjStart_M.RampInjSpeedStep = InjStart_M.RampInjSpeedStep2;
            }

            //ջתٵݼ
            if(InjStart_M.RampInjCurrRef < InjStart_M.RampInjCurrTarget)
               InjStart_M.RampInjCurrRef += InjStart_M.RampInjCurrStep;
            else if (InjStart_M.RampInjCurrRef > InjStart_M.RampInjCurrTarget)
               InjStart_M.RampInjCurrRef -= InjStart_M.RampInjCurrStep;

           if(InjStart_M.RampInjSpeedRef < InjStart_M.RampInjSpeedTarget)
               InjStart_M.RampInjSpeedRef += InjStart_M.RampInjSpeedStep;
           else if(InjStart_M.RampInjSpeedRef > InjStart_M.RampInjSpeedTarget)
               InjStart_M.RampInjSpeedRef -= InjStart_M.RampInjSpeedStep;

            //ջǶȼ
            InjStart_M.RampInjAngle = InjStart_M.RampInjAngle +\
                                     _IQMPY_MACRO(InjStart_M.RampInjSpeedRef,InjStart_M.K_WetoPosi);

            //Ƕ0-1PU֮
            InjStart_M.RampInjAngle = Round_Circle_Limitation_PU(InjStart_M.RampInjAngle);

            //ȡǶȵҺֵ
            Struct_Cossin_M = TrigonoMetric_Function(InjStart_M.RampInjAngle);

            StatCurrRef2R_M.cd = InjStart_M.RampInjCurrRef;//dֵ
            StatCurrRef2R_M.cq = 0;//q0

            if(InjStart_M.RampInjCounter >= (InjStart_M.RampInjStage1))//ʼLBG۲
            {
                if(_IQabs(StatCurr2R_M.cd)>=_IQMPY_MACRO(InjStart_M.CurrErrThresh,\
                        _IQabs(StatCurrRef2R_M.cd)))
                {
                    //LBG۲Ƽʼ
                    LBG_EMF_CalInitial(&StatVoltRef2S_M,&StatCurr2S_M,_IQ(1.0),&InjStart_M,&LBG_Cal_M,&LBG_EMF_InitPara_M);

                    //LBG۲˲ʼ
                    if (LBG_Adaptor_M.Enable ==1)
                    LBG_Adaptor_CalInitial(&LBG_Cal_M,&LBG_Adaptor_M);

                    //LGG۲תٳʼ
                    LBG_Speed_CalInitial(&LBG_Cal_M,&(LBG_SpeedBuffer_M[0]),&LBG_Speed_PLL_M,\
                                          InjStart_M.RampInjSpeedRef,LBG_SpeedBuffPara_M.Length);

                    //LBG۲Ƽ
                    LBG_EMF_Cal(&StatVoltRef2S_M,&StatCurr2S_M,_IQ(1.0),&LBG_Cal_M,&LBG_Para_M);

                    //LBG۲תٺͽǶȼ
                    LBG_Speed_Posi_Cal(&LBG_Cal_M,&LBG_Speed_PLL_M,&LBG_Adaptor_M);

                    //ȡ۲ϵǶȵҺֵ
                    InjStart_M.Triangle = TrigonoMetric_Function(LBG_Cal_M.PosiElecPU);

                    //۲ϵµdqʵʵ
                    InjStart_M.Curr_2R = Park_TransForm(&StatCurr2S_M,&InjStart_M.Triangle);

                    InjStart_M.VoltRef_2R = Park_TransForm(&StatVoltRef2S_M,&InjStart_M.Triangle);

                    //תָʾ˸
                    if (LBG_Status_M.Convergence == TRUE)
                        LED_Flicker(OBSERVER_CONVERGE_FLICKER_TIME, &ConvergeFlickCnt,\
                                GPIOB, GPIO_Pin_3, &ConvergeFlickCtr);
                }
                else //ʼսϴжΪʧ
                {
                    Protection_SetFault(STARTUP_FAILURE_M);
                    printf("Motor_StartFailure=%d\r\n",1111);
                }
            }

          //תٱջʼ
            if ((LBG_Status_M.Convergence == TRUE))
            {
                //ٶȻʼ
                SpeedRamp_M.Aftramp = LBG_Cal_M.Angspeed_Aver1;
                SpeedRegStruc_M.Output_Prev = InjStart_M.Curr_2R.cq;
                SpeedRegStruc_M.Output_New = InjStart_M.Curr_2R.cq;

                //dʼ
                StatCurrRef2R_M.cd = InjStart_M.Curr_2R.cd;
                dCurrRegStruc_M.Output_Prev = InjStart_M.VoltRef_2R.cd;
                dCurrRegStruc_M.Output_New = InjStart_M.VoltRef_2R.cd;

                //qʼ
                StatCurrRef2R_M.cq = InjStart_M.Curr_2R.cq;
                qCurrRegStruc_M.Output_Prev = InjStart_M.VoltRef_2R.cq;
                qCurrRegStruc_M.Output_New = InjStart_M.VoltRef_2R.cq;

                //Ƕȳʼ
                Struct_Cossin_M.Sin = InjStart_M.Triangle.Sin;
                Struct_Cossin_M.Cos = InjStart_M.Triangle.Cos;

                //״̬лRUN״̬
                RunningStatus_M = RUN;

                //ָʾƵֹ˸״̬Ϩ
                Running_LED_Lighton(GPIOB, GPIO_Pin_3);
            }

            //һʱڻûת뿪ʧ
            if (InjStart_M.RampInjCounter >=InjStart_M.RampInjStage2)
            {
               Protection_SetFault(STARTUP_FAILURE_M);
               printf("Motor_StartFailure=%d\r\n",1111);
            }
            break;

        default:
            break;
      }

    //۲ʼõֵ
    if(LBG_Cal_M.CalCnt ==0)
    {
        LBG_Cal_M.CalphaPrev = StatCurr2S_M.Alpha;
        LBG_Cal_M.CbetaPrev = StatCurr2S_M.Beta;
    }

    //ȡ
    StatCurr3S_M = Current_Cal_2R(&ADC_M,ADC1);

    //ྲֹϵ
    StatCurr2S_M = Clark_TransForm(&StatCurr3S_M);

    //תϵ
    StatCurr2R_M = Park_TransForm(&StatCurr2S_M,&Struct_Cossin_M);

    //d
    StatVoltRef2R_M.cd = PID_Calculaion (StatCurrRef2R_M.cd,StatCurr2R_M.cd, &dCurrRegStruc_M);

    //q
    StatVoltRef2R_M.cq = PID_Calculaion (StatCurrRef2R_M.cq,StatCurr2R_M.cq, &qCurrRegStruc_M);

    //dqѹ޷
    StatVoltRef2R_M = ComponentLimit_2Ror2S(&StatVoltRef2R_M , MAX_MODULATION,&(SVPWM_Cal_M.VoltLimMark),Magnitude_table);

    //alphabetaѹֵ
    StatVoltRef2S_M  = Rev_Park_TransForm(&StatVoltRef2R_M , &Struct_Cossin_M);

    //SVPWM㣬ʼ
    SVPWM_Calculation(&SVPWM_Cal_M,&StatVoltRef2S_M,TIM1);

    //ADCʱ̼
    ADC_Trigger(&SVPWM_Cal_M,ADC1,TIM1);
}
